package dxgames.internalglassframe;

import java.awt.Component;

import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;
import javax.swing.JOptionPane;
import javax.swing.JRootPane;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;


public class InternalGlassFrame {
	private JDesktopPane glass=null;
	private JRootPane parentFrame=null;
	private JDesktopPane desktopPane=null;
	private Component orgGlassPane=null;
	
	public InternalGlassFrame(JRootPane p_parentFrame, JDesktopPane p_desktopPane)
	{
		 glass = new PrintGlassPane();
		 //glass.setLayout(null);
         parentFrame=p_parentFrame;
         desktopPane=p_desktopPane;
	}
	
	
	public void showInternalMessage(
			Object p_message,String p_title)
	{
		showInternalMessage(
				p_message,
				p_title,
				JOptionPane.INFORMATION_MESSAGE
				);
	}
	public void showInternalMessage(
			Object p_message,String p_title, int p_messageType)
	{
		
     
       
        JOptionPane optionPane=new JOptionPane();
        optionPane.setMessage(p_message);
        optionPane.setMessageType(p_messageType);
        JInternalFrame modal = optionPane.createInternalFrame(
        		desktopPane, p_title);
       
        
        
        
        
        
          
	}
	
	public void showInternalFrame(JInternalFrame p_internalFrame)
	{
		showInternalFrame(p_internalFrame,true,true);
	}
	
	public void showInternalFrame(JInternalFrame p_internalFrame,
		boolean p_bAddCloseListener)
	{
		showInternalFrame(p_internalFrame,p_bAddCloseListener,
				true);
	}
	
	public void showInternalFrame(JInternalFrame p_internalFrame,
			boolean p_bAddCloseListener,boolean p_bCenter)
	{
		
		glass.setVisible(false);

		if (p_bAddCloseListener)
		{
			orgGlassPane = parentFrame.getGlassPane();
			
			p_internalFrame.addInternalFrameListener(new InternalFrameAdapter() {
				public void internalFrameClosed(InternalFrameEvent e) {
					glass.setVisible(false);
					parentFrame.setGlassPane(orgGlassPane);
				}
			});
		}
		
        glass.add(p_internalFrame);
        p_internalFrame.setLocation(
        		(int)((parentFrame.getContentPane().getWidth()
        				-p_internalFrame.getWidth())*0.5), 
        		(int)((parentFrame.getContentPane().getHeight()
        				-p_internalFrame.getHeight())*0.5));
        //Rectangle screen = desktopPane.getBounds();
        /*p_internalFrame.setLocation(screen.x + screen.width/2 
        		- p_internalFrame.getSize().width/2,
                          screen.y + screen.height/2 
                          - p_internalFrame.getSize().height/2);*/
        parentFrame.setGlassPane(glass);
        glass.setVisible(true);
        p_internalFrame.setVisible(true);
        try{
        	p_internalFrame.setSelected(true);
          }catch(java.beans.PropertyVetoException ex) {}
	}
}
