package dxgames.internalglassframe;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.LayoutManager;
import java.awt.TexturePaint;

import javax.swing.JDesktopPane;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.SwingUtilities;


public class PrintGlassPane extends JDesktopPane {
    private final TexturePaint texture = TextureFactory.createCheckerTexture(4);
    public PrintGlassPane() {
        super();
    }
    @Override
    public void setVisible(boolean isVisible) {
        boolean oldVisible = isVisible();
        super.setVisible(isVisible);
        JRootPane rootPane = SwingUtilities.getRootPane(this);
        if(rootPane!=null && isVisible()!=oldVisible) {
            rootPane.getLayeredPane().setVisible(!isVisible);
        }
    }
    @Override
    public void paintComponent(Graphics g) {
        JRootPane rootPane = SwingUtilities.getRootPane(this);
        if (rootPane != null) {
            // http://weblogs.java.net/blog/alexfromsun/archive/2008/01/disabling_swing.html
            // it is important to call print() instead of paint() here
            // because print() doesn't affect the frame's double buffer
            rootPane.getLayeredPane().print(g);
        }
        Graphics2D g2 = (Graphics2D) g;
        g2.setPaint(texture);
        g2.fillRect(0,0,getWidth(),getHeight());
    }
}
