package dxgames.internalglassframe;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.TexturePaint;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;


class TextureFactory{
    private static final Color defaultColor = new Color(100,100,100,100);
    public static TexturePaint createCheckerTexture(int cs, Color color) {
        int size = cs*cs;
        BufferedImage img = new BufferedImage(size,size,BufferedImage.TYPE_4BYTE_ABGR);
        Graphics2D g2 = img.createGraphics();
        g2.setPaint(color);
        g2.fillRect(0,0,size,size);
        for(int i=0;i*cs<size;i++) {
            for(int j=0;j*cs<size;j++) {
                if((i+j)%2==0)
                  g2.fillRect(i*cs, j*cs, cs, cs);
            }
        }
        g2.dispose();
        return new TexturePaint(img, new Rectangle2D.Double(0,0,size,size));
    }
    public static TexturePaint createCheckerTexture(int cs) {
        return createCheckerTexture(cs, defaultColor);
    }
}
